#include <bits/stdc++.h>

using namespace std;

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n,q;
    cin>>n>>q;
    vector<pair<int,int>>napadi;
    for(int i=0;i<n;i++){
        int a,b;
        cin>>a>>b;
        napadi.push_back(make_pair(a,b));
    }
    for(int i=0;i<q;i++){
        int bos;
        cin>>bos;
        int tot=0;
        int br=-1;
        for(int j=0;j<n;j++){
            bos-=tot;
            if(napadi[j].second==0){
                bos-=napadi[j].first;
            }
            else if(napadi[j].first==0){
                bos-=napadi[j].second;
                tot+=napadi[j].second;
            }
            else if(napadi[j].second>=napadi[j].first){
                bos-=napadi[j].second;
                tot+=napadi[j].second;
            }
            else{
                int a=bos-napadi[j].first-tot;
                int b=bos-napadi[j].second-tot;
                if(bos-a<bos-b){
                    bos-=napadi[j].first;
                }
                else{
                    bos-=napadi[j].second;
                    tot+=napadi[j].second;
                }
            }
            if(bos<=0){
                br=j+1;
                break;
            }
            if(bos-tot<0){
                br=j+1;
                break;
            }

        }
       //
       cout<<br<<endl;
    }
    return 0;
}